/**
 * 
 */
package lumiukko;

import java.awt.BorderLayout;
import java.awt.EventQueue;
import java.awt.Point;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.WindowConstants;
import javax.swing.border.EmptyBorder;

import fi.jyu.mit.Music.BufferedMidiPlayer2;
import fi.jyu.mit.graphics.Circle;
import fi.jyu.mit.graphics.SpacePanel;

/**
 * @author vesal
 * @version Feb 5, 2012
 *
 */
public class Lumiukko extends JFrame {

    private static final long serialVersionUID = 1L;
    private JPanel contentPane;
    private final SpacePanel spacePanel = new SpacePanel();


    /**
     * Launch the application.
     * @param args ei käytössä
     */
    public static void main(String[] args) {
        EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                try {
                    Lumiukko frame = new Lumiukko();
                    frame.setVisible(true);
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        });
    }


    /**
     * Create the frame.
     */
    public Lumiukko() {
        setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        setBounds(100, 100, 450, 300);
        contentPane = new JPanel();
        contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
        contentPane.setLayout(new BorderLayout(0, 0));
        setContentPane(contentPane);
        spacePanel.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent e) {
                if ( e.getButton() == MouseEvent.BUTTON1 )
                    ukko(e.getPoint());
                else if ( e.getButton() == MouseEvent.BUTTON3 )
                    soitaAllMyLoving();
                else 
                    soitaPinkPanther();
            }
        });
        
        contentPane.add(spacePanel, BorderLayout.CENTER);
        lumiukko(spacePanel,20,80);
        // soitaAllMyLoving();
    }


    /**
     * @param point paikka johon ukko piirretään
     */
    protected void ukko(Point point) {
        lumiukko(spacePanel, point.x, point.y);
        soitaUkkoNoa();
    }


    /**
     * Piirtää lumiukon
     * @param window ikkuna johon piirretään
     * @param x ukon alapallon x-koordinaatti
     * @param y ukon alapallon y-koordinaatti
     */
    public static void lumiukko(SpacePanel window, double x, double y) {
        window.add(new Circle(x,y-2*15-20-10,10));
        window.add(new Circle(x,y-15-20,15));
        window.add(new Circle(x,y,20));
    }


    private static BufferedMidiPlayer2 mp = new BufferedMidiPlayer2();
    
    /**
     * Soittaa UkkoNoaa midi-soittimella
     */
    public static void soitaUkkoNoa() {
        //MidiPlayer mp = new MidiPlayer();
        mp.stop();
        mp.setTempo(150);
        mp.setInstrument(20);
        mp.setVerbose(true);
        mp.play("CCCEDDDFEEDDC*");
        mp.play("EEEEG*F*DDDDF*E*");
        mp.play("CCCEDDDFEEDDC*");
        mp.runAsync();    
        // mp.run();
    }
    
    
    /**
     * John Lennon and Paul MacCartney, 1963: "All my loving": 
     * http://www.musicnotes.com/sheetmusic/mtd.asp?ppn=MN0053910
     */
    public static void soitaAllMyLoving() {
        // BufferedMidiPlayer2 mp = new BufferedMidiPlayer2();
        mp.stop();
        mp.printInstruments();
        mp.setInstrument(0,mp.getInstrumentIndex("Steel-str.Gt"));
        mp.setTempo(144);
        // mp.setInstrument(1,mp.getInstrumentIndex("Organ 3"));
        mp.setInstrument(1,mp.getInstrumentIndex("Fingered Bs."));
        double t=0.25;

        mp.play(0,"    F   E | D*     E  F  | G  A*     H ",t,4);
        mp.play(1,"    -   - | D*4          | G*    F*    ",t,3);

        mp.play(0,"C5* C5 H  | A  E*2    A  | A*    A  G  ",t,4); 
        mp.play(1,"E*4       | A*     E*    | F*3      E  ",t,3); 

        mp.play(0,"F*  D  C  | D*4          | B3*   F  E  ",t,4);
        mp.play(1,"D*4       | Bb2*   F*    | G*    -*    ",t,3);

        mp.play(0,"D*  E  F  | G*     A  H  | C5*   C5 H  ",t,4);
        mp.play(1,"D*4       | G*     F*    | E*4         ",t,3);

        mp.play(0,"A   E*2 A | A*     A  G  | F*    E  D  ",t,4);
        mp.play(1,"A*   E*   | F*3       E  | D*4         ",t,3);
                
        mp.play(0,"C*4",t,4);
        mp.play(1,"E*4",t,3);
        
        mp.play("---");

        mp.runAsync();   
    }
    

    /**
     * Henry Manchini, 1963:  "The Pink Panther": http://www.musicnotes.com/sheetmusic/mtd.asp?ppn=MN0026839
     */
    public static void soitaPinkPanther() {
        mp.stop();
        mp.setInstrument(mp.getInstrumentIndex("Trum.*"));
        mp.setTempo(150);
        double t=0.25;      
        mp.play("G#/4 A/2 -/4 A#/4 | B*6.5 -/4 G#/4  A/ -/4  A#/4 | B*6.5 ",t,4);

        mp.play("/4 Bb/4  A/ -/4 Ab/4 G*6.5 -/4 G#/4 A/ -/4 A#/4 B*6 -*0.75 D#/4 ",t,4); 
        
        for (int i=0;i<2; i++) {
          mp.play("E  -*0.75 F#/4 G -*0.75 D#/4 E*0.75 F#/4 G*0.75 C5/4 B*0.75 E/4 G*0.75 B/4 Bb*2.333 A/3 G/3 E/3 D/3 E*2.334",t,4);
        
          mp.play("-*0.75 D#/4 E -*0.75 F#/4 G -*0.75 D#/4 E*0.75 F#/4 G*0.75 C5/4 B*0.75 G/4 B*0.75 E5/4 Eb5*6.5 -*0.75 D#/4",t,4);
        }  
        mp.play("---");

        mp.runAsync();   
    }
    
    
}