package lumiukkoFX;

import java.awt.BorderLayout;
import java.awt.Point;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.JPanel;
import javax.swing.SwingUtilities;

import javafx.application.Application;
import javafx.embed.swing.SwingNode;
import javafx.scene.Scene;
import javafx.scene.layout.StackPane;
import javafx.stage.Stage;
import fi.jyu.mit.graphics.*;

import static lumiukko.Lumiukko.*;

/**
 * Lumiukkoja FX-ohjelmaan
 * @author vesal
 * @version 7.2.2016
 */
public class LumiukotFX extends Application {

    @Override
    public void start(Stage stage) {
        final SwingNode swingNode = new SwingNode();
        createAndSetSwingContent(swingNode);

        StackPane pane = new StackPane();
        pane.getChildren().add(swingNode);

        stage.setScene(new Scene(pane, 400, 300));
        stage.show();
    }
    

    private void createAndSetSwingContent(final SwingNode swingNode) {
        SwingUtilities.invokeLater(new Runnable() {
            @Override
            public void run() {
                SpacePanel spacePanel = new SpacePanel();
                JPanel panel = new JPanel();
                panel.setLayout(new BorderLayout(0, 0));
                panel.add(spacePanel, BorderLayout.CENTER);
                swingNode.setContent(panel);
                // ukko(spacePanel, new Point(50,50));
                lumiukko(spacePanel, 100, 100);
                spacePanel.addMouseListener(new MouseAdapter() {
                    @Override
                    public void mouseClicked(MouseEvent e) {
                        if ( e.getButton() == MouseEvent.BUTTON1 )
                            ukko(spacePanel, e.getPoint());
                        else if ( e.getButton() == MouseEvent.BUTTON3 )
                            soitaAllMyLoving();
                        else 
                            soitaPinkPanther();
                    }
                });

            }
        });
    }

    
    /**
     * @param args ei käytössä
     */
    public static void main(String[] args) {
        launch(args);
    }
    
    
    /**
     * @param spacePanel mihin piirretään
     * @param point paikka johon ukko piirretään
     */
    protected void ukko(SpacePanel spacePanel, Point point) {
        lumiukko(spacePanel, point.x, point.y);
        soitaUkkoNoa();
    }

}
